/*
 * ============================================================================
 *                   The Solar Software License, Version 1.0
 * ============================================================================
 *
 *       Copyright (C) 2002-2003 Dartmouth College. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modifica-
 * tion, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of  source code must  retain the above copyright  notice,
 *    this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * 3. The  names  "Solar"  and   "Dartmouth  College"  must  not  be  used   to 
 *    endorse  or   promote   products  derived   from this  software   without
 *    prior  written   permission.   For  written   permission,  please contact 
 *    solar@cs.dartmouth.edu.
 * 
 * 4. Products  derived from this software may not  be called "Solar", nor may
 *    "Solar" appear  in their name,  without prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
 * DARTMOUTH COLLEGE OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY  DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY,  OR   CONSEQUENTIAL   DAMAGES   (INCLUDING
 * BUT  NOT  LIMITED  TO, PROCUREMENT OF SUBSTITUTE  GOODS  OR  SERVICES;  LOSS
 * OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
 * ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
 * (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * This software  consists of voluntary contributions made  by many individuals
 * on behalf of the Solar project at Dartmouth College. For more information on
 * the Solar project, please see <http://www.cs.dartmouth.edu/~solar/>.

 */

package campus.syslog;


import java.io.File;
import java.net.URL;
import java.util.Hashtable;


/**
 *  A structure for AP's Configuration infomation 
 *  @author     Yurong Xu 
 *  @version    $Id: APConfiguration.java,v 1.1 2003/08/28 18:30:06 glchen Exp $
 */
public class APConfiguration
{
    public String aPName;

    public int antennaType;  // dipole=1, paddle=2, directional=3 
    public String aPType; 
    public String buildingName;
    public String location;
    public int frequency;
    public int power;
    public String iPAddress;
    public String gateway;
    public String mACAddress;
    


    //------------------------------------------------------------------------
    // constructors.
    //------------------------------------------------------------------------
    
    /** Constructs a AP Configuration structure with specified parameters. */
    APConfiguration(String aPName, String buildingName, int antennaType, String aPType, String location, int frequency, int power, String iPAddress, String gateway, String mACAddress)
    {
         this.aPName= aPName;
         this.buildingName=buildingName;
         this.antennaType=antennaType; // dipole=1, paddle=2, directional=3 
         this.aPType=aPType;
         this.location=location;
         this.frequency=frequency;
         this.power=power;
         this.iPAddress=iPAddress;
         this.gateway=gateway;
         this.mACAddress=mACAddress;
    }
}
