/*
 * ============================================================================
 *                   The Solar Software License, Version 1.0
 * ============================================================================
 *
 *       Copyright (C) 2002-2003 Dartmouth College. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modifica-
 * tion, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of  source code must  retain the above copyright  notice,
 *    this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * 3. The  names  "Solar"  and   "Dartmouth  College"  must  not  be  used   to 
 *    endorse  or   promote   products  derived   from this  software   without
 *    prior  written   permission.   For  written   permission,  please contact 
 *    solar@cs.dartmouth.edu.
 * 
 * 4. Products  derived from this software may not  be called "Solar", nor may
 *    "Solar" appear  in their name,  without prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
 * DARTMOUTH COLLEGE OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY  DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY,  OR   CONSEQUENTIAL   DAMAGES   (INCLUDING
 * BUT  NOT  LIMITED  TO, PROCUREMENT OF SUBSTITUTE  GOODS  OR  SERVICES;  LOSS
 * OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
 * ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
 * (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * This software  consists of voluntary contributions made  by many individuals
 * on behalf of the Solar project at Dartmouth College. For more information on
 * the Solar project, please see <http://www.cs.dartmouth.edu/~solar/>.

 */

package solar.service.directory;


import java.util.Set;
import java.util.Iterator;
import java.util.Hashtable;

import solar.api.Address;
import solar.api.Attribute;
import solar.api.AttributeRecord;


/**
 *  A hierarchical directory containing all or part of registered names,
 *  not implemented yet.
 *  
 *  @author     Guanling Chen
 *  @version    $Id: TreeDirectory.java,v 1.3 2003/10/05 18:50:56 glchen Exp $
 */
class TreeDirectory
{
    protected NameNode _root;

    /*
    //=======================================================================
    //  Constructors.
    //=======================================================================

    public TreeNameSpace()
    {
        _root = new NameNode("/");
    }


    //=======================================================================
    //  Public interface methods.
    //=======================================================================

    public void addListener(Name pattern, NameListener listener)
    {
        
    }

    public void removeListener(Name pattern, NameListener listener)
    {
        
    }

    public Hashtable lookup(Name pattern)
    {
        return doLookup(pattern);
    }

    public void advertise(Name name, NameRecord rec)
    {
        doAdvertise(_root, name, rec);
    }

    public void unadvertise(Name name, NameRecord rec)
    {
        doUnadvertise(_root, name, rec);        
    }

    public void update(Name oldName, Name newName, NameRecord rec)
    {
        unadvertise(oldName, rec);
        advertise(newName, rec);
    }


    //=======================================================================
    //  Private helper methods.
    //=======================================================================

    private Hashtable doLookup(Name pattern)
    {
        Set records = null;
        
        return null;
    }

    private void doAdvertise(NameNode root, 
        AttributeRecord name, NameRecord rec)
    {
        Iterator itr = name.getAttributes().iterator();
        while (itr.hasNext())
        {
            Attribute attr = (Attribute) itr.next();
            String key = attr.getKey();
            NameNode cnode = root.getChild(key);
            cnode = (cnode == null) ? root.createChild(key) : cnode;

            Object val = attr.getValue();
            if (val instanceof AttributeRecord)
            {
                doAdvertise(cnode, (AttributeRecord) val, rec);
            }
            else    // it is a string
            {
                String value = (String) val;
                NameNode vnode = cnode.getChild(value);
                vnode = (vnode == null) ? cnode.createChild(value) : vnode;
                vnode.addRecord(rec);
            }
        }
    }

    private void doUnadvertise(NameNode root, 
        AttributeRecord name, NameRecord rec)
    {
        Iterator itr = name.getAttributes().iterator();
        while (itr.hasNext())
        {
            Attribute attr = (Attribute) itr.next();
            String key = attr.getKey();
            NameNode cnode = root.getChild(key);
            if (cnode == null) return;

            Object val = attr.getValue();
            if (val instanceof AttributeRecord)
            {
                doUnadvertise(cnode, (AttributeRecord) val, rec);
            }
            else    // it is a string
            {
                String value = (String) val;
                NameNode vnode = cnode.getChild(value);
                if (vnode == null) return;
                vnode.removeRecord(rec);
            }
        }
    }*/
}
